//+------------------------------------------------------------------+
//|                                            Murrey_Math_MT_VG.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Vladislav Goshkov (VG)."
#property link      "4vg@mail.ru"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  FireBrick
#property indicator_color2  DarkOrange
#property indicator_color3  DeepSkyBlue
#property indicator_color4  DarkOrange
#property indicator_color5  HotPink
#property indicator_color6  Lime
#property indicator_color7  SteelBlue
#property indicator_color8  Lime

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 2
#property indicator_width8 2

// ============================================================================================
// *  8/8  0/8 ( ).
// *          .
// ============================================================================================
//*  7/8  (,     ). Weak, Stall and Reverse
//*   .               , 
//*     .       ,      8/8.
// ============================================================================================
//*  1/8  (,     ). Weak, Stall and Reverse
//*   .               , 
//*     .       ,      0/8.
// ============================================================================================
//*  6/8  2/8 (, ). Pivot, Reverse
//*         4/8       .
// ============================================================================================
//*  5/8 (  ). Top of Trading Range
//*     40% ,    5/8  3/8 . 
//*      5/8       10-12 ,     
//*     ,     ,       
//*  5/8,      . , ,    5/8,      
//*      .
// ============================================================================================
//*  3/8 (  ). Bottom of Trading Range
//*        ,       . 
//*            10-12 ,       
//*   40%       5/8 .
// ============================================================================================
//*  4/8 (  /). Major Support/Resistance
//*     /.         . 
//*     4/8,     .     4/8,     
//* .
// ============================================================================================
extern int P = 300;
extern int TextShift=0;
extern int code=158;

double  dmml = 0,
        dvtl = 0,
        sum  = 0,
        v1 = 0,
        v2 = 0,
        mn = 0,
        mx = 0,
        x1 = 0,
        x2 = 0,
        x3 = 0,
        x4 = 0,
        x5 = 0,
        x6 = 0,
        y1 = 0,
        y2 = 0,
        y3 = 0,
        y4 = 0,
        y5 = 0,
        y6 = 0,
        octave = 0,
        fractal = 0,
        range   = 0,
        finalH  = 0,
        finalL  = 0,
        mml[8];

string  ln_txt[8],        
        buff_str = "";
        
int     
        bn_v1   = 0,
        bn_v2   = 0,
        OctLinesCnt = 8,
        mml_thk = 8,
        mml_clr[8],
        mml_shft = 3,
        nTime = 0,
        CurPeriod = 0,
        nDigits = 0,
        i = 0;
double Buffer_1[];
double Buffer_2[];
double Buffer_3[];
double Buffer_4[];
double Buffer_5[];
double Buffer_6[];
double Buffer_7[];
double Buffer_8[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexBuffer(0,Buffer_1);
   SetIndexArrow(0,code);
   SetIndexDrawBegin(0,P+1);
   SetIndexEmptyValue(0,0.0);
//----   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(1,Buffer_2);
   SetIndexArrow(1,code);
   SetIndexDrawBegin(1,P+1);
   SetIndexEmptyValue(1,0.0);
//----   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexBuffer(2,Buffer_3);
   SetIndexArrow(2,code);
   SetIndexDrawBegin(2,P+1);
   SetIndexEmptyValue(2,0.0);
//----   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(3,Buffer_4);
   SetIndexArrow(3,code);
   SetIndexDrawBegin(3,P+1);
   SetIndexEmptyValue(3,0.0);
//----   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexBuffer(4,Buffer_5);
   SetIndexArrow(4,code);
   SetIndexDrawBegin(4,P+1);
   SetIndexEmptyValue(4,0.0);
//----   
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexBuffer(5,Buffer_6);
   SetIndexArrow(5,code);
   SetIndexDrawBegin(5,P+1);
   SetIndexEmptyValue(5,0.0);
//----   
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexBuffer(6,Buffer_7);
   SetIndexArrow(6,code);
   SetIndexDrawBegin(6,P+1);
   SetIndexEmptyValue(6,0.0);
//----   
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexBuffer(7,Buffer_8);
   SetIndexArrow(7,code);
   SetIndexDrawBegin(7,P+1);
   SetIndexEmptyValue(7,0.0);
//----   
   SetIndexLabel(0,"[-2/8] ,   ") ;
   SetIndexLabel(1,"[-1/8]    ") ;
   SetIndexLabel(2,"[0/8]  ,   4/8  ")  ;
   SetIndexLabel(3,"[1/8]  ,   0/8  ") ;
   SetIndexLabel(4,"[2/8] ,  0/8  ")   ;
   SetIndexLabel(5,"[3/8]    ")  ;
   SetIndexLabel(6,"[4/8]       ")  ;
   SetIndexLabel(7,"[5/8]    ") ;
   
   ln_txt[0]  = "                                                 -2/8";// "extremely overshoot [-2/8]";// [-2/8]
   ln_txt[1]  = "                                                 -1/8";// "overshoot [-1/8]";// [-1/8]
   ln_txt[2]  = "                                                  0/8";// "Ultimate Support - extremely oversold [0/8]";// [0/8]
   ln_txt[3]  = "                                                  1/8";// "Weak, Stall and Reverse - [1/8]";// [1/8]
   ln_txt[4]  = "                                                  2/8";// "Pivot, Reverse - major [2/8]";// [2/8]
   ln_txt[5]  = "                                                  3/8";// "Bottom of Trading Range - [3/8], if 10-12 bars then 40% Time. BUY Premium Zone";//[3/8]
   ln_txt[6]  = "                                                  4/8";// "Major Support/Resistance Pivotal Point [4/8]- Best New BUY or SELL level";// [4/8]
   ln_txt[7]  = "                                                  5/8";// "Top of Trading Range - [5/8], if 10-12 bars then 40% Time. SELL Premium Zone";//[5/8]
   

   mml_shft = TextShift;
   mml_thk  = 1;

   //      
   mml_clr[0]  = DimGray;   // [-2]/8
   mml_clr[1]  = DimGray;  // [-1]/8
   mml_clr[2]  = DimGray; //  [0]/8
   mml_clr[3]  = DimGray;        //  [1]/8
   mml_clr[4]  = LightSlateGray;     //  [2]/8
   mml_clr[5]  = DimGray;        //  [3]/8
   mml_clr[6]  = DimGray;   //  [4]/8
   mml_clr[7]  = DimGray;        //  [5]/8
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
  {
//----
    for(i=0;i<OctLinesCnt;i++) 
     {
      buff_str = "mml_txt"+i;
      ObjectDelete(buff_str);
     } 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
 int limit;
 int counted_bars=IndicatorCounted();
//----
 if(counted_bars<0) return(-1);
//----
 if(counted_bars>0) counted_bars--;
 limit=Bars-counted_bars;
//---- TODO: add your code here

//if( (nTime != Time[0]) || (CurPeriod != Period()) ) 
//{
 for(int shift=limit-1; shift>=0; shift--)
  {  
  //price
   bn_v1 = iLowest(NULL,0,MODE_LOW,P,shift);
   bn_v2 = iHighest(NULL,0,MODE_HIGH,P,shift);

   v1 = Low[bn_v1];
   v2 = High[bn_v2];

//determine fractal.....
   if( v2<=250000 && v2>25000 )
   fractal=100000;
   else
     if( v2<=25000 && v2>2500 )
     fractal=10000;
     else
       if( v2<=2500 && v2>250 )
       fractal=1000;
       else
         if( v2<=250 && v2>25 )
         fractal=100;
         else
           if( v2<=25 && v2>12.5 )
           fractal=12.5;
           else
             if( v2<=12.5 && v2>6.25)
             fractal=12.5;
             else
               if( v2<=6.25 && v2>3.125 )
               fractal=6.25;
               else
                 if( v2<=3.125 && v2>1.5625 )
                 fractal=3.125;
                 else
                   if( v2<=1.5625 && v2>0.390625 )
                   fractal=1.5625;
                   else
                     if( v2<=0.390625 && v2>0)
                     fractal=0.1953125;
      
   range=(v2-v1);
   sum=MathFloor(MathLog(fractal/range)/MathLog(2));
   octave=fractal*(MathPow(0.5,sum));
   mn=MathFloor(v1/octave)*octave;
   if( (mn+octave)>v2 )
   mx=mn+octave; 
   else
     mx=mn+(2*octave);


// calculating xx
//x2
    if( (v1>=(3*(mx-mn)/16+mn)) && (v2<=(9*(mx-mn)/16+mn)) )
    x2=mn+(mx-mn)/2; 
    else x2=0;
//x1
    if( (v1>=(mn-(mx-mn)/8))&& (v2<=(5*(mx-mn)/8+mn)) && (x2==0) )
    x1=mn+(mx-mn)/2; 
    else x1=0;

//x4
    if( (v1>=(mn+7*(mx-mn)/16))&& (v2<=(13*(mx-mn)/16+mn)) )
    x4=mn+3*(mx-mn)/4; 
    else x4=0;

//x5
    if( (v1>=(mn+3*(mx-mn)/8))&& (v2<=(9*(mx-mn)/8+mn))&& (x4==0) )
    x5=mx; 
    else  x5=0;

//x3
    if( (v1>=(mn+(mx-mn)/8))&& (v2<=(7*(mx-mn)/8+mn))&& (x1==0) && (x2==0) && (x4==0) && (x5==0) )
    x3=mn+3*(mx-mn)/4; 
    else x3=0;

//x6
    if( (x1+x2+x3+x4+x5) ==0 )
    x6=mx; 
    else x6=0;

     finalH = x1+x2+x3+x4+x5+x6;
// calculating yy
//y1
    if( x1>0 )
    y1=mn; 
    else y1=0;

//y2
    if( x2>0 )
    y2=mn+(mx-mn)/4; 
    else y2=0;

//y3
    if( x3>0 )
    y3=mn+(mx-mn)/4; 
    else y3=0;

//y4
    if( x4>0 )
    y4=mn+(mx-mn)/2; 
    else y4=0;

//y5
    if( x5>0 )
    y5=mn+(mx-mn)/2; 
    else y5=0;

//y6
    if( (finalH>0) && ((y1+y2+y3+y4+y5)==0) )
    y6=mn; 
    else y6=0;

    finalL = y1+y2+y3+y4+y5+y6;

    for( i=0; i<OctLinesCnt; i++) {
         mml[i] = 0;
         }
         
   dmml = (finalH-finalL)/8;

   mml[0] =(finalL-dmml*2); //-2/8
   for( i=1; i<OctLinesCnt; i++) {
        mml[i] = mml[i-1] + dmml;
        }
   Buffer_1[shift]=mml[0];
   Buffer_2[shift]=mml[1];
   Buffer_3[shift]=mml[2];
   Buffer_4[shift]=mml[3];   
   Buffer_5[shift]=mml[4];
   Buffer_6[shift]=mml[5];   
   Buffer_7[shift]=mml[6];
   Buffer_8[shift]=mml[7];        
         
    // for( i=1; i<=OctLinesCnt; i++ ){
  }
   //nTime    = Time[0];
   //CurPeriod= Period();

   //}
  
  for( i=0; i<OctLinesCnt; i++ ){
        buff_str = "mml_txt"+i;
        if(ObjectFind(buff_str) == -1) {
           ObjectCreate(buff_str, OBJ_TEXT, 0, Time[mml_shft], mml_shft);
           ObjectSetText(buff_str, ln_txt[i]+" ("+DoubleToStr(mml[i],Digits)+")", 9, "Arial", mml_clr[i]);
           ObjectMove(buff_str, 0, Time[mml_shft],  mml[i]);
           }
        else {
           ObjectMove(buff_str, 0, Time[mml_shft],  mml[i]);
           }
        }
//---- End Of Program        
  return(0);
  }
//+------------------------------------------------------------------+